diff -Nur irc2.10.3p7/ircd/s_serv.c irc2.10.3p7+hemp2+DK+B5/ircd/s_serv.c
--- irc2.10.3p7/ircd/s_serv.c	Mon Mar  1 19:00:33 2004
+++ irc2.10.3p7+hemp2+DK+B5/ircd/s_serv.c	Tue May 11 15:25:04 2004
@@ -517,7 +517,11 @@
 		/* A server can only be introduced by another server. */
 		if (!IsServer(sptr))
 		    {
-			sendto_flag(SCH_LOCAL,
+#ifdef LOCAL_REJECTIONS_ONLY
+				sendto_flag(SCH_NOTICE,
+#else
+				sendto_flag(SCH_LOCAL,
+#endif
 			    "Squitting %s brought by %s (introduced by %s)",
 				    host, get_client_name(cptr, FALSE),
 				    sptr->name);
@@ -605,11 +609,38 @@
 		if (acptr->info != DefInfo)
 			MyFree(acptr->info);
 		acptr->info = mystrdup(info);
-		acptr->serv->up = sptr->name;
+		acptr->serv->up = mystrdup(sptr->name);
 		acptr->serv->stok = token;
 		acptr->serv->snum = find_server_num(acptr->name);
 		SetServer(acptr);
 		istat.is_serv++;
+#ifdef	EXTRA_STATISTICS
+		/*
+		**  Keep track of the highest number of connected
+		**  servers (hostmasks) to this network.
+		**/
+		if (istat.is_serv > istat.is_m_serv)
+			istat.is_m_serv = istat.is_serv;
+		acptr->serv->usermax = restore_server_max(acptr->name);
+#endif
+#ifdef 	SPLIT_HANDLE
+		SetBurst(acptr);
+		sendto_one(cptr,":%s PING %s :%s",my_name_for_link(ME,cptr->serv->nline->port),
+			my_name_for_link(ME,cptr->serv->nline->port),
+			acptr->name);
+#endif
+		/* add server to downlink list */
+		{
+			Link *lp;
+
+			lp = make_link();
+			bzero((char *)lp, sizeof(Link));
+			lp->value.cptr = acptr;
+			lp->next = sptr->serv->down;
+			/* we keep number of downlinks in flags */
+			lp->flags = sptr->serv->down ? sptr->serv->down->flags + 1 : 1;
+			sptr->serv->down = lp;
+		}
 		add_client_to_list(acptr);
 		(void)add_to_client_hash_table(acptr->name, acptr);
 		(void)add_to_server_hash_table(acptr->serv, cptr);
@@ -857,16 +888,50 @@
 	**	code is more neat this way...  --msa
 	*/
 	SetServer(cptr);
+#ifdef SPLIT_HANDLE
+	SetBurst(cptr);
+#endif
 	istat.is_unknown--;
 	istat.is_serv++;
+#ifdef	EXTRA_STATISTICS
+	/*
+	**  Keep track of the highest number of connected
+	**  servers to this network.
+	**/
+	if (istat.is_serv > istat.is_m_serv)
+		istat.is_m_serv = istat.is_serv;
+#endif
 	istat.is_myserv++;
+#ifdef	EXTRA_STATISTICS
+	/*
+	**  Keep track of the highest number of servers which
+	**  this server has had connected simultaniously.
+	*/
+	if (istat.is_myserv > istat.is_m_myserv)
+		istat.is_m_myserv = istat.is_myserv;
+#endif
+
+#ifdef SERVER_MAP
+		/* add server to downlink list */
+		{
+			Link *lp;
+
+			lp = make_link();
+			bzero((char *)lp, sizeof(Link));
+			lp->value.cptr = cptr;
+			lp->next = me.serv->down;
+			/* we keep number of downlinks in flags */
+			lp->flags = me.serv->down ? me.serv->down->flags + 1 : 1;
+			me.serv->down = lp;
+		}
+#endif
 	nextping = timeofday;
 	sendto_flag(SCH_NOTICE, "Link with %s established. (%X%s)", inpath,
 		    cptr->hopcount, (cptr->flags & FLAGS_ZIP) ? "z" : "");
 	(void)add_to_client_hash_table(cptr->name, cptr);
 	/* doesnt duplicate cptr->serv if allocted this struct already */
 	(void)make_server(cptr);
-	cptr->serv->up = me.name;
+	cptr->serv->up = mystrdup(me.name);
 	cptr->serv->nline = aconf;
 	cptr->serv->version = cptr->hopcount;   /* temporary location */
 	cptr->hopcount = 1;			/* local server connection */
@@ -877,6 +942,9 @@
 	Debug((DEBUG_NOTICE, "Server link established with %s V%X %d",
 		cptr->name, cptr->serv->version, cptr->serv->stok));
 	add_fd(cptr->fd, &fdas);
+#ifdef EXTRA_STATISTICS
+	cptr->serv->usermax = restore_server_max(cptr->name);
+#endif
 #ifdef	USE_SERVICES
 	check_services_butone(SERVICE_WANT_SERVER, cptr->name, cptr,
 			      ":%s SERVER %s %d %s :%s", ME, cptr->name,
@@ -1004,7 +1072,10 @@
 				send_channel_modes(cptr, chptr);
 			    }
 	    }
-
+#ifdef SPLIT_HANDLE
+	/* send PING- emulate EOB */
+	sendto_one(cptr,":%s PING %s %s",my_name_for_link(ME, aconf->port),my_name_for_link(ME, aconf->port),cptr->name);
+#endif
 	cptr->flags &= ~FLAGS_CBURST;
 #ifdef	ZIP_LINKS
  	/*
@@ -1079,7 +1150,11 @@
 {
 	char **text = infotext;
 
-	if (IsServer(cptr) && check_link(cptr))
+	if (
+#ifdef NO_OPER_TRYAGAIN
+		!IsOper(sptr) &&
+#endif
+		IsServer(cptr) && check_link(cptr))
 	    {
 		sendto_one(sptr, rpl_str(RPL_TRYAGAIN, parv[0]),
 			   "INFO");
@@ -1312,6 +1387,9 @@
 {
 	static	char	null[] = "<NULL>";
 	aConfItem *tmp;
+#ifdef ILINE_FLAGS
+	char nmbuf[HOSTLEN*2];
+#endif
 	int	*p, port;
 	char	c, *host, *pass, *name;
 	
@@ -1320,14 +1398,61 @@
 		if (tmp->status & mask)
 		    {
 			for (p = &report_array[0][0]; *p; p += 3)
-				if (*p == tmp->status)
+				if ((*p & tmp->status) && !(*p & CONF_ILLEGAL))
 					break;
 			if (!*p)
 				continue;
 			c = (char)*(p+2);
 			host = BadPtr(tmp->host) ? null : tmp->host;
 			pass = BadPtr(tmp->passwd) ? NULL : tmp->passwd;
-			name = BadPtr(tmp->name) ? null : tmp->name;
+#ifdef ILINE_FLAGS
+			if ((tmp->status & (CONF_CLIENT | CONF_RCLIENT)) &&
+					tmp->status & (CONF_EXEMPT|CONF_RNODNS))
+			{
+				if ((tmp->status & CONF_EXEMPT) &&
+				     tmp->status & CONF_RNODNS)
+				{
+					if (BadPtr(tmp->name))
+					{
+						name = "<EXEMPT|RNODNS>";
+					}
+					else
+					{
+						sprintf(nmbuf,"+<%s",tmp->name);
+						name = nmbuf;
+					}
+				}
+				else if (tmp->status & CONF_EXEMPT)
+				{
+					if (BadPtr(tmp->name))
+					{
+						name = "<EXEMPT>";
+					}
+					else
+					{
+						sprintf(nmbuf,"<%s",tmp->name);
+						name = nmbuf;
+					}
+
+				}
+				else
+				{
+					if (BadPtr(tmp->name))
+					{
+						name = "<RNODNS>";
+					}
+					else
+					{
+						sprintf(nmbuf,"+%s",tmp->name);
+						name = nmbuf;
+					}
+				}
+			}
+			else
+#endif
+			{
+				name = BadPtr(tmp->name) ? null : tmp->name;
+			}
 			port = (int)tmp->port;
 			/*
 			 * On K/V lines the passwd contents can be
@@ -1369,7 +1494,151 @@
 		    }
 	return;
 }
+#ifdef STATS_F
+static void report_fd(sptr,acptr,to)
+aClient *sptr, *acptr;
+char *to;
+{
+	static char locip[100], *ret;
+	int s;
+
+	if (IsMe(acptr) || !acptr->acpt || !IsRegistered(acptr))
+		return;
+	ret = 
+#ifdef INET6
+		inetntop(AF_INET6,
+		(char *)&acptr->acpt->ip,
+		mydummy, MYDUMMY_SIZE),
+#else
+		inetntoa((char *)&acptr->acpt->ip);
+#endif
+	s = strlen(ret) + 1;
+	memcpy(locip, ret, s < sizeof(locip) ? s : sizeof(locip));
+	locip[sizeof(locip) - 1] = 0;
+	sendto_one(sptr,":%s %d %s %d %s %d %s %d %s %s %d",
+		ME,RPL_STATSLINKINFO,to,
+		acptr->fd,
+		locip,
+		acptr->acpt->port,
+#ifdef INET6
+		inetntop(AF_INET6,
+		(char *)&acptr->ip,
+		mydummy, MYDUMMY_SIZE),
+#else
+		inetntoa((char *)&acptr->ip),
+#endif
+		acptr->port,acptr->name,
+		acptr->user ? acptr->user->username : acptr->auth,
+		acptr->user ? timeofday - acptr->user->last : -1
+		);
+}
+#endif /* STATS_F */
+#ifdef STATS_QMARK
+/* show quick info about connected servers */
+static void report_myservers(sptr,to)
+aClient *sptr;
+char *to;
+{
+	int i;
+	int timeconnected;
+	aClient *acptr;
+	aServer *asptr;
+	int users = 0, servers = 0;
 
+	for (i = fdas.highest; i >= 0; i--)
+	{
+		if (!(acptr = local[fdas.fd[i]]))
+		{
+			continue;
+		}
+		
+		if (IsMe(acptr) || !IsServer(acptr))
+		{
+			continue;
+		}
+		users = 0;
+		servers = 0;
+
+		timeconnected = timeofday - acptr->firsttime;
+#ifdef HUB
+                        for (asptr = svrtop;asptr;asptr = asptr->nexts)
+                        {
+                                if (asptr->bcptr->from == acptr)
+                                {
+                                        servers++;
+                                        users += asptr->usercnt[0];
+					users += asptr->usercnt[1];
+				}
+			}
+#else /* !HUB */
+			servers = istat.is_serv - 1;
+			users = istat.is_user[0] + istat.is_user[1];
+			users -= istat.is_myclnt;
+#endif
+		sendto_one(sptr,":%s %d %s : %s (%d, %02d:%02d:%02d) %dS %dC %ldkB sent %ldkB recv %ldkB sq%s",
+			   ME,RPL_STATSDEBUG,to,acptr->name,
+			   timeconnected / 86400,(timeconnected % 86400) / 3600,
+			   (timeconnected % 3600)/60,
+			   timeconnected % 60,servers,users,acptr->sendK,acptr->receiveK,(int) (
+	                   (int)DBufLength(&acptr->sendQ) / 1024),
+#ifdef SPLIT_HANDLE
+			   IsBurst(acptr) ? " BURST" : ""
+#else
+			   ""
+#endif
+			   );
+	}
+}
+#endif
+#ifdef DELAY_ACCEPT
+static void report_listeners(sptr,to)
+aClient *sptr;
+char *to;
+{
+	aConfItem *tmp;
+	int active,comma;
+	for (tmp = conf; tmp; tmp = tmp->next)
+	{
+		if (!(tmp->status & CONF_LISTEN_PORT))
+		{
+			continue;
+		}
+
+		/* this SUUUUX, we need some nice list of all listeners!
+		 * - jv
+		 */
+		if (tmp->status & CONF_ACTIVE)
+		{
+			active = 1;
+		}
+		else
+		{
+			active = 0;
+		}
+		*buf = 0;
+		comma = 0;
+		if (tmp->status & CONF_DELAY)
+		{
+			strcat(buf,"delay");
+			comma = 1;
+		}
+		
+		if (tmp->status & CONF_SERVERONLY)
+		{
+			if (comma)
+			{
+				strcat(buf,",");
+			}
+			strcat(buf,"server-only");
+		}
+		
+		sendto_one(sptr,":%s %d %s :%d %s %s",ME,RPL_STATSDEFINE,to,
+				tmp->port,active ? "active" : "inactive",buf);
+		
+	}
+}
+	
+#endif
 int	m_stats(cptr, sptr, parc, parv)
 aClient *cptr, *sptr;
 int	parc;
@@ -1430,14 +1699,35 @@
 				2, parc, parv) != HUNTED_ISME)
 			return 5;
 	    }
-
 	name = (parc > 2) ? parv[2] : ME;
 	cm = (parc > 3) ? parv[3]: name;
 	doall = !match(name, ME) && !match(cm, ME);
 	wilds = index(cm, '*') || index(cm, '?');
+	
+	/* no stats, just dumb client */
+	if (parv[1] && !mycmp(parv[1],ME))
+	{
+		return 2;
+	}
+	
+#ifdef CLIENTS_CHANNEL
+       if (stat && (sptr->user)) {
+		sendto_flag(SCH_CLIENTS,"Stats %c by %s from %s on %s",
+			stat,sptr->name,sptr->user->username,sptr->user->host);
+       }
+#endif
 
 	switch (stat)
 	{
+#ifdef STATS_F
+	case 'f' : case 'F' : /* send FD list */
+		if (!IsOper(sptr) || !MyConnect(sptr))
+		{
+			stat = '*';
+			break;
+		}
+		stat = 'f';
+#endif
 	case 'L' : case 'l' :
 		/*
 		 * send info about connections which match, or all if the
@@ -1457,6 +1747,13 @@
 			    {
 				if (!(acptr = local[i]))
 					continue;
+#ifdef STATS_F
+				if (stat == 'f')
+				{
+					report_fd(sptr, acptr, parv[0]);
+					continue;
+				}
+#endif	
 				if (IsPerson(acptr) && !(MyConnect(sptr) 
 				    && IsAnOper(sptr)) && acptr != sptr)
 					continue;
@@ -1475,7 +1772,12 @@
 		else
 		    {
 			if ((acptr = find_client(cm, NULL)) && MyConnect(acptr))
-				sendto_one(cptr, Lformat, ME,
+#ifdef STATS_F
+				if (stat == 'f')
+					report_fd(sptr, acptr, parv[0]);
+				else
+#endif
+					sendto_one(cptr, Lformat, ME,
 					RPL_STATSLINKINFO, parv[0],
 					get_client_name(acptr, isupper(stat)),
 					(int)DBufLength(&acptr->sendQ),
@@ -1511,6 +1813,14 @@
 					CONF_CLIENT|CONF_RCLIENT);
 		break;
 	case 'K' : case 'k' : /* K lines */
+#ifdef NOSTATSK
+                if (!IsAnOper(sptr))
+                {
+                        sendto_one(sptr, err_str(ERR_STATSKLINE, parv[0]));
+                        return 2;
+                }
+                else
+#endif
 		report_configured_links(cptr, parv[0],
 					(CONF_KILL|CONF_OTHERKILL));
 		break;
@@ -1540,8 +1850,24 @@
 	case 'S' : case 's' : /* S lines */
 		report_configured_links(cptr, parv[0], CONF_SERVICE);
 		break;
+#ifdef	EXTRA_STATISTICS
+	case 'T' : /* various statistics for operators only */
+		if (MyOper(sptr)) {
+			tstats(cptr, parv[0], 2);
+			break;
+		}
+	case 't' : /* various statistics for operators only */
+		if (MyOper(sptr)) {
+			tstats(cptr, parv[0], 1);
+			break;
+		}
+
+		/* various statistics */
+		tstats(cptr, parv[0], 0);
+#else
 	case 'T' : case 't' : /* various statistics */
 		tstats(cptr, parv[0]);
+#endif
 		break;
 	case 'U' : case 'u' : /* uptime */
 	    {
@@ -1572,6 +1898,11 @@
 	case 'z' :	      /* memory use */
 		count_memory(cptr, parv[0], 0);
 		break;
+#ifdef STATS_QMARK
+	case '?' :
+		report_myservers(sptr,parv[0]);
+		break;
+#endif
 	default :
 		stat = '*';
 		break;
@@ -1690,122 +2021,118 @@
 int	parc;
 char	*parv[];
     {
-	int	s_count = 0,	/* server */
-		c_count = 0,	/* client (visible) */
-		u_count = 0,	/* unknown */
-		i_count = 0,	/* invisible client */
-		o_count = 0,	/* oparator */
-		v_count = 0;	/* service */
-	int	m_client = 0,	/* my clients */
-		m_server = 0,	/* my server links */
-		m_service = 0;	/* my services */
-	aClient *acptr;
-
+	int		s_count = 0,	/* server */
+			c_count = 0,	/* visible client */
+			u_count = 0,	/* unknown */
+			i_count = 0,	/* invisible client */
+			o_count = 0,	/* operator */
+			v_count = 0;	/* service */
+	int		m_client = 0,	/* my clients */
+			m_server = 0,	/* my server links */
+			m_service = 0;	/* my services */
+	int		mask_max = 0;	/* max of given mask */
+	
 	if (parc > 2)
 		if (hunt_server(cptr, sptr, ":%s LUSERS %s :%s", 2, parc, parv)
 		    != HUNTED_ISME)
 			return 3;
 
 	if (parc == 1 || !MyConnect(sptr))
-	    {
-		sendto_one(sptr, rpl_str(RPL_LUSERCLIENT, parv[0]),
-			   istat.is_user[0] + istat.is_user[1],
-			   istat.is_service, istat.is_serv);
-		if (istat.is_oper)
-			sendto_one(sptr, rpl_str(RPL_LUSEROP, parv[0]),
-				   istat.is_oper);
-		if (istat.is_unknown > 0)
-			sendto_one(sptr, rpl_str(RPL_LUSERUNKNOWN, parv[0]),
-				   istat.is_unknown);
-		if (istat.is_chan)
-			sendto_one(sptr, rpl_str(RPL_LUSERCHANNELS, parv[0]),
-				   istat.is_chan);
-		sendto_one(sptr, rpl_str(RPL_LUSERME, parv[0]),
-			   istat.is_myclnt, istat.is_myservice,
-			   istat.is_myserv);
-		return 2;
-	    }
-	(void)collapse(parv[1]);
-	for (acptr = client; acptr; acptr = acptr->next)
-	    {
-		if (!IsServer(acptr) && acptr->user)
-		    {
-			if (match(parv[1], acptr->user->server))
-				continue;
-		    }
-		else
-      			if (match(parv[1], acptr->name))
-				continue;
+	{
+		s_count = istat.is_serv;
+		c_count = istat.is_user[0];
+		i_count = istat.is_user[1];
+		u_count = istat.is_unknown;
+		o_count = istat.is_oper;
+		v_count = istat.is_service;
+		m_client = istat.is_myclnt;
+		m_server = istat.is_myserv;
+		m_service = istat.is_myservice;
+#ifdef EXTRA_STATISTICS
+		mask_max = istat.is_m_users;
+#endif
+	}
+	else
+	{	
+		aClient 	*acptr;
+        	aServer 	*asptr;
+		aService 	*svcp;
+		
+		(void)collapse(parv[1]);
+		
+		/* LUSERS <mask> */
+		for (asptr = svrtop;asptr;asptr = asptr->nexts)
+		{
+			if (!match(parv[1],asptr->bcptr->name))
+			{
+				s_count++;
+				
+				c_count += asptr->usercnt[0];
+				i_count += asptr->usercnt[1];
+				o_count += asptr->usercnt[2];
+				/* not exact probably, but oh well... */
+#ifdef EXTRA_STATISTICS
+				mask_max += asptr->usermax;				
+#endif
+				if (IsMe(asptr->bcptr))
+				{
+					m_client = istat.is_myclnt;
+					m_server = istat.is_myserv;
+					m_service = istat.is_myservice;
+					u_count = istat.is_unknown;
 
-		switch (acptr->status)
+				}
+			}
+		}
+	
+		/* Count services, but only if we found some matching server
+		 * before (to prevent wrong matches on masks like *irc*). - jv
+		 */
+		if (s_count)
 		{
-		case STAT_SERVER:
-			if (MyConnect(acptr))
-				m_server++;
-			/* flow thru */
-		case STAT_ME:
-			s_count++;
-			break;
-		case STAT_SERVICE:
-			if (MyConnect(acptr))
-				m_service++;
-			v_count++;
-			break;
-		case STAT_CLIENT:
-			if (IsOper(acptr))
-				o_count++;
-#ifdef	SHOW_INVISIBLE_LUSERS
-			if (MyConnect(acptr))
-		  		m_client++;
-			if (!IsInvisible(acptr))
-				c_count++;
-			else
-				i_count++;
-#else
-			if (MyConnect(acptr))
-			    {
-				if (IsInvisible(acptr))
-				    {
-					if (IsAnOper(sptr))
-						m_client++;
-				    }
-				else
-					m_client++;
-			    }
-	 		if (!IsInvisible(acptr))
-				c_count++;
-			else
-				i_count++;
-#endif
-			break;
-		default:
-			u_count++;
-			break;
-	 	}
-	     }
-#ifndef	SHOW_INVISIBLE_LUSERS
-	if (IsAnOper(sptr) && i_count)
+			for (svcp = svctop;svcp;svcp = svcp->nexts)
+			{
+				if (!match(parv[1],svcp->servp->bcptr->name))
+				{
+					v_count++;
+				}
+			}
+		}
+	}
+	
+#ifndef SHOW_INVISIBLE_LUSERS
+	if (!IsOper(sptr))
+	{
+		i_count = 0;
+	}
 #endif
 	sendto_one(sptr, rpl_str(RPL_LUSERCLIENT, parv[0]),
 		   c_count + i_count, v_count, s_count);
-#ifndef	SHOW_INVISIBLE_LUSERS
-	else
-		sendto_one(sptr, rpl_str(RPL_LUSERCLIENT, parv[0]),
-			   c_count, v_count, s_count);
-#endif
 	if (o_count)
+	{
 		sendto_one(sptr, rpl_str(RPL_LUSEROP, parv[0]), o_count);
-	if (u_count > 0)
+	}
+	if (u_count)
+	{
 		sendto_one(sptr, rpl_str(RPL_LUSERUNKNOWN, parv[0]), u_count);
-	if ((c_count = count_channels(sptr))>0)
-		sendto_one(sptr, rpl_str(RPL_LUSERCHANNELS, parv[0]),
-			   count_channels(sptr));
+	}
+	sendto_one(sptr, rpl_str(RPL_LUSERCHANNELS, parv[0]),istat.is_chan);
 	sendto_one(sptr, rpl_str(RPL_LUSERME, parv[0]), m_client, m_service,
 		   m_server);
+#ifdef EXTRA_STATISTICS
+	if (m_client)
+	{
+		sendto_one(sptr, rpl_str(RPL_LOCALUSERS, parv[0]),
+				istat.is_myclnt, istat.is_m_myclnt);
+	}
+	sendto_one(sptr, rpl_str(RPL_GLOBALUSERS, parv[0]),
+			 c_count + i_count, mask_max);
+#endif
+	
 	return 2;
     }
 
-  
+
 /***********************************************************************
  * m_connect() - Added by Jto 11 Feb 1989
  ***********************************************************************/
@@ -1836,7 +2163,7 @@
 		       3,parc,parv) != HUNTED_ISME)
 		return 1;
 
-	if (parc < 3 || *parv[1] == '\0')
+	if (parc < 2 || *parv[1] == '\0')
 	    {
 		sendto_one(sptr, err_str(ERR_NEEDMOREPARAMS, parv[0]),
 			   "CONNECT");
@@ -1879,18 +2206,34 @@
 	** from there, then use the precompiled default.
 	*/
 	tmpport = port = aconf->port;
-	if ((port = atoi(parv[2])) <= 0)
-	    {
+
+	if (parc > 2)
+	{
+		port = atoi(parv[2]);
+	}
+	if (parc < 3 || !port)
+	{
+		if (tmpport < 0)
+		{
+			port = 0 - port;
+		}
+		else
+		{
+			port = tmpport;
+		}
+
+		if (!port)
+		{
+			sendto_one(sptr, ":%s NOTICE %s :Connect: missing port number",
+				   ME, parv[0]);
+			return 0;
+		}
+	}
+	if (port < 0)
+	{
 		sendto_one(sptr, "NOTICE %s :Connect: Illegal port number",
 			   parv[0]);
-		return 0;
-	    }
-	else if (port <= 0)
-	    {
-		sendto_one(sptr, ":%s NOTICE %s :Connect: missing port number",
-			   ME, parv[0]);
-		return 0;
-	    }
+	}
 	/*
 	** Notify all operators about remote connect requests
 	*/
@@ -2040,6 +2383,14 @@
 #ifdef USE_SYSLOG
 	syslog(LOG_INFO, "REHASH From %s\n", get_client_name(sptr, FALSE));
 #endif
+#ifdef DELAY_CLOSE
+        if (parc >1 && parv[1] && *parv[1] == 'd')
+        {
+                delay_close(-2,NULL);
+		sendto_flag(SCH_NOTICE,
+		    "%s is forcing closing of delay closed sockets", parv[0]);
+        }
+#endif
 	return rehash(cptr, sptr, (parc > 1) ? ((*parv[1] == 'q')?2:0) : 0);
 }
 #endif
@@ -2087,171 +2438,236 @@
 }
 #endif
 
-/*
-** m_trace
-**	parv[0] = sender prefix
-**	parv[1] = servername
-*/
-int	m_trace(cptr, sptr, parc, parv)
-aClient *cptr, *sptr;
-int	parc;
-char	*parv[];
+void trace_one(to,sptr,acptr)
+char *to;
+aClient *sptr,*acptr;
 {
-	Reg	int	i;
-	Reg	aClient	*acptr;
-	aClass	*cltmp;
-	char	*tname;
-	int	doall, link_s[MAXCONNECTIONS], link_u[MAXCONNECTIONS];
-	int	wilds, dow;
-
-	if (parc > 1)
-		tname = parv[1];
-	else
-		tname = ME;
-
-	switch (hunt_server(cptr, sptr, ":%s TRACE :%s", 1, parc, parv))
-	{
-	case HUNTED_PASS: /* note: gets here only if parv[1] exists */
-	    {
-		aClient	*ac2ptr;
-
-		ac2ptr = next_client(client, parv[1]);
-		sendto_one(sptr, rpl_str(RPL_TRACELINK, parv[0]),
-			   version, debugmode, tname, ac2ptr->from->name,
-			   ac2ptr->from->serv->version,
-			   (ac2ptr->from->flags & FLAGS_ZIP) ? "z" : "",
-			   timeofday - ac2ptr->from->firsttime,
-			   (int)DBufLength(&ac2ptr->from->sendQ),
-			   (int)DBufLength(&sptr->from->sendQ));
-		return 5;
-	    }
-	case HUNTED_ISME:
-		break;
-	default:
-		return 1;
-	}
+	char *name;
+	int class;
 
-	doall = (parv[1] && (parc > 1)) ? !match(tname, ME): TRUE;
-	wilds = !parv[1] || index(tname, '*') || index(tname, '?');
-	dow = wilds || doall;
-
-	if (doall) {
-		for (i = 0; i < MAXCONNECTIONS; i++)
-			link_s[i] = 0, link_u[i] = 0;
-		for (acptr = client; acptr; acptr = acptr->next)
-#ifdef	SHOW_INVISIBLE_LUSERS
-			if (IsPerson(acptr))
-				link_u[acptr->from->fd]++;
-#else
-			if (IsPerson(acptr) &&
-			    (!IsInvisible(acptr) || IsOper(sptr)))
-				link_u[acptr->from->fd]++;
-#endif
-			else if (IsServer(acptr))
-				link_s[acptr->from->fd]++;
-	}
-
-	/* report all direct connections */
+	name = get_client_name(acptr,FALSE);
+	class = get_client_class(acptr);
 	
-	for (i = 0; i <= highest_fd; i++)
-	    {
-		char	*name;
-		int	class;
-
-		if (!(acptr = local[i])) /* Local Connection? */
-			continue;
-		if (IsPerson(acptr) && IsInvisible(acptr) && dow &&
-		    !(MyConnect(sptr) && IsAnOper(sptr)) &&
-		    !IsAnOper(acptr) && (acptr != sptr))
-			continue;
-		if (!doall && wilds && match(tname, acptr->name))
-			continue;
-		if (!dow && mycmp(tname, acptr->name))
-			continue;
-		name = get_client_name(acptr,FALSE);
-		class = get_client_class(acptr);
-
-		switch(acptr->status)
-		{
+	switch (acptr->status)
+	{
 		case STAT_CONNECTING:
 			sendto_one(sptr, rpl_str(RPL_TRACECONNECTING,
-				   parv[0]), class, name);
-			break;
+						to), class, name);
+	    	break;
+			
 		case STAT_HANDSHAKE:
-			sendto_one(sptr, rpl_str(RPL_TRACEHANDSHAKE, parv[0]),
-				   class, name);
+			sendto_one(sptr, rpl_str(RPL_TRACEHANDSHAKE, to),
+						class, name);
 			break;
+
 		case STAT_ME:
 			break;
+		
 		case STAT_UNKNOWN:
-			if (IsAnOper(sptr) || (MyPerson(sptr) && SendWallops(sptr)))
-				sendto_one(sptr,
-					   rpl_str(RPL_TRACEUNKNOWN, parv[0]),
+				sendto_one(sptr,rpl_str(RPL_TRACEUNKNOWN, to),
 					   class, name);
 			break;
+	
 		case STAT_CLIENT:
-			/* Only opers see users if there is a wildcard
-			 * but anyone can see all the opers.
-			 */
 			if (IsAnOper(acptr))
-				sendto_one(sptr,
-					   rpl_str(RPL_TRACEOPERATOR, parv[0]),
-					   class, name);
-			else if (!dow || (MyConnect(sptr) && IsAnOper(sptr)))
-				sendto_one(sptr,
-					   rpl_str(RPL_TRACEUSER, parv[0]),
-					   class, name);
+			{
+				sendto_one(sptr,rpl_str(RPL_TRACEOPERATOR,
+						to),class, name);
+			}
+			else
+			{
+				sendto_one(sptr,rpl_str(RPL_TRACEUSER,
+					to),class, name);
+			}
+
 			break;
+			
 		case STAT_SERVER:
+		{
+			/* we need to count servers/users behind this link */
+			int servers = 0, users = 0;
+			aServer *asptr;
+			aClient *next;
+#ifdef HUB
+			for (asptr = svrtop;asptr;asptr = asptr->nexts)
+			{
+				if (asptr->bcptr->from == acptr)
+				{
+					servers++;
+					users += asptr->usercnt[0];
+#ifdef SHOW_INVISIBLE_LUSERS
+					users += asptr->usercnt[1];						
+#endif
+				}
+			}
+#else /* !HUB */
+				/* we can have only one server linked */
+			servers = istat.is_serv - 1;
+			users = istat.is_user[0];
+#ifdef SHOW_INVISIBLE_LUSERS
+			users += istat.is_user[1];
+			users -= istat.is_myclnt;
+#else
+			users -= me.usercnt[0];
+#endif
+#endif /* HUB */
+	
 			if (acptr->serv->user)
-				sendto_one(sptr, rpl_str(RPL_TRACESERVER,
-					   parv[0]), class, link_s[i],
-					   link_u[i], name, acptr->serv->by,
-					   acptr->serv->user->username,
-					   acptr->serv->user->host,
-					   acptr->serv->version,
-					   (acptr->flags & FLAGS_ZIP) ?"z":"");
+			{
+					sendto_one(sptr, rpl_str(RPL_TRACESERVER,
+								to), class, servers, users, name, 
+								acptr->serv->by, acptr->serv->user->username,
+                                acptr->serv->user->host, acptr->serv->version,
+								(acptr->flags & FLAGS_ZIP) ?"z":"");
+			}
 			else
+			{
 				sendto_one(sptr, rpl_str(RPL_TRACESERVER,
-					   parv[0]), class, link_s[i],
-					   link_u[i], name,
-					   *(acptr->serv->by) ?
-					   acptr->serv->by : "*", "*", ME,
-					   acptr->serv->version,
-					   (acptr->flags & FLAGS_ZIP) ?"z":"");			break;
+						   to), class, servers, users, name,
+						   *(acptr->serv->by) ?  acptr->serv->by : "*", "*", 
+						   ME, acptr->serv->version,
+						   (acptr->flags & FLAGS_ZIP) ?"z":"");
+			}
+			break;
+		}	
 		case STAT_RECONNECT:
-			sendto_one(sptr, rpl_str(RPL_TRACERECONNECT, parv[0]),
-				   class, name);
+			sendto_one(sptr, rpl_str(RPL_TRACERECONNECT, to),
+						class, name);
 			break;
+			
 		case STAT_SERVICE:
-			sendto_one(sptr, rpl_str(RPL_TRACESERVICE, parv[0]),
-				   class, name, acptr->service->type,
-				   acptr->service->wants);
+        				sendto_one(sptr, rpl_str(RPL_TRACESERVICE, to),
+                                   class, name, acptr->service->type,
+                                   acptr->service->wants);
 			break;
+			
 		case STAT_LOG:
-			sendto_one(sptr, rpl_str(RPL_TRACELOG, parv[0]),
-				   ME, acptr->port);
+			sendto_one(sptr, rpl_str(RPL_TRACELOG, to),
+                                   ME, acptr->port);
 			break;
+			
 		default: /* ...we actually shouldn't come here... --msa */
-			sendto_one(sptr, rpl_str(RPL_TRACENEWTYPE, parv[0]),
-				   name);
-			break;
-		}
-	    }
+			sendto_one(sptr, rpl_str(RPL_TRACENEWTYPE, to),
+                       name);
+        	break;
+	}
+}
 
-	/*
-	 * Add these lines to summarize the above which can get rather long
-	 * and messy when done remotely - Avalon
-	 */
-	if (IsPerson(sptr) && SendWallops(sptr))
-	    for (cltmp = FirstClass(); doall && cltmp; cltmp = NextClass(cltmp))
-		if (Links(cltmp) > 0)
-			sendto_one(sptr, rpl_str(RPL_TRACECLASS, parv[0]),
-				   Class(cltmp), Links(cltmp));
-	sendto_one(sptr, rpl_str(RPL_TRACEEND, parv[0]), tname, version,
+/*
+ * m_trace
+ * 	parv[0] = sender prefix
+ * 	parv[1] = traced nick/server/service
+ */
+int	m_trace(cptr, sptr, parc, parv)
+aClient *cptr, *sptr;
+int	parc;
+char	*parv[];
+{
+	aClient *acptr;
+	int maskedserv = 0;
+	int i = 0;
+	
+	if (parc > 1)
+	{
+		/* wildcards now allowed only in server/service names */
+		acptr = find_matching_client(parv[1],NULL);
+		if (!acptr)
+		{
+			sendto_one(sptr, err_str(ERR_NOSUCHSERVER,
+					parv[0]), parv[1]);
+			return 1;
+		}
+		if (IsServer(acptr))
+		{
+			if (!match(acptr->name,parv[1]))
+			{
+				/* if we are tracing masked server,
+				 * we have to send parv[1], not acptr->name
+				 */
+				maskedserv = 1;
+			}
+		}
+	}
+	else
+	{
+		acptr = &me;
+	}
+	if (!IsMe(acptr))
+	{
+		if (!MyConnect(acptr) || IsServer(acptr))
+		{
+#ifdef RESTRICT_RESTRICTED
+			if (MyConnect(sptr) && IsRestricted(sptr))
+			{
+				sendto_one(sptr,err_str(ERR_RESTRICTED,parv[0]));
+				return 5;
+			}
+#endif
+			if (acptr->from == cptr)
+			{	/* eek ?! */
+				return 1;
+			}
+			/* passthru */
+              		sendto_one(sptr, rpl_str(RPL_TRACELINK, parv[0]),
+	      	                   version, debugmode, (maskedserv) ? parv[1] : acptr->name, acptr->from->name,
+				   acptr->from->serv->version,
+				   (acptr->from->flags & FLAGS_ZIP) ? "z" : "",
+        	               	   timeofday - acptr->from->firsttime,
+                	           (int)DBufLength(&acptr->from->sendQ),
+                        	   (int)DBufLength(&sptr->from->sendQ));
+			sendto_one(acptr,":%s TRACE :%s",sptr->name, (maskedserv) ? parv[1] : acptr->name);
+			return 5;
+		}
+		else
+		{
+			/* tracing something local */
+			trace_one(parv[0],sptr,acptr);	
+		}
+	}
+	else
+	{
+		/* well, report everything */
+		aClient *a2cptr;
+		
+		for (i = 0; i <= highest_fd; i++)
+		{
+			if (!(a2cptr = local[i]))
+			{
+				continue;
+			}
+			if (IsMe(a2cptr))
+			{
+				continue;
+			}
+			if (IsPerson(a2cptr) && !(a2cptr == sptr || IsAnOper(a2cptr) ||
+						(IsAnOper(sptr) && MyConnect(sptr))) )
+			{
+				continue;
+			}
+			if (IsUnknown(a2cptr) && !((IsAnOper(sptr) || MyClient(sptr))
+						&& SendWallops(sptr)) )
+			{
+				continue;
+			}
+			trace_one(parv[0],sptr,a2cptr);	
+		}
+		if (IsPerson(sptr) && SendWallops(sptr))
+		{
+			aClass  *cltmp;
+		    	for (cltmp = FirstClass(); cltmp; cltmp = NextClass(cltmp))
+		    	{
+				if (Links(cltmp) > 0)
+				{
+					sendto_one(sptr, rpl_str(RPL_TRACECLASS, parv[0]),
+					   Class(cltmp), Links(cltmp));
+				}
+	   		}
+		}
+	}
+	sendto_one(sptr, rpl_str(RPL_TRACEEND, parv[0]), acptr->name, version,
 		   debugmode);
 	return 2;
-    }
+}
 
 /*
 ** m_motd
@@ -2274,7 +2690,11 @@
 	struct	tm	*tm;
 #endif
 
-	if (check_link(cptr))
+	if (
+#ifdef NO_OPER_TRYAGAIN
+		!IsOper(sptr) &&
+#endif
+		check_link(cptr))
 	    {
 		sendto_one(sptr, rpl_str(RPL_TRYAGAIN, parv[0]), "MOTD");
 		return 5;
